Index: /palm/trunk/SOURCE/modules.f90
===================================================================
--- /palm/trunk/SOURCE/modules.f90	(revision 2276)
+++ /palm/trunk/SOURCE/modules.f90	(revision 2277)
@@ -887,510 +898,505 @@
 
     TYPE file_status
-       LOGICAL ::  opened         !< 
-       LOGICAL ::  opened_before  !< 
+       LOGICAL ::  opened         !< Siggi
+       LOGICAL ::  opened_before  !< Siggi
     END TYPE file_status
     
-    INTEGER, PARAMETER      ::  mask_xyz_dimension = 100  !< 
-    INTEGER, PARAMETER      ::  max_masks = 50            !< 
+    INTEGER, PARAMETER      ::  mask_xyz_dimension = 100  !< limit of mask dimensions (100 points in each direction)
+    INTEGER, PARAMETER      ::  max_masks = 50            !< maximum number of masks
     INTEGER(iwp), PARAMETER ::  varnamelength = 30        !< length of output variable names
 
-    TYPE(file_status), DIMENSION(200+2*max_masks) ::                &  !< 
+    TYPE(file_status), DIMENSION(200+2*max_masks) ::                &  !< Siggi
                              openfile = file_status(.FALSE.,.FALSE.)
 
-    CHARACTER (LEN=1)    ::  cycle_mg = 'w'                               !< 
-    CHARACTER (LEN=1)    ::  timestep_reason = ' '                        !< 
-    CHARACTER (LEN=3)    ::  coupling_char = ''                           !< 
-    CHARACTER (LEN=5)    ::  write_binary = 'false'                       !< 
-    CHARACTER (LEN=8)    ::  most_method = 'newton'                       !< NAMELIST parameter defining method to be used to calculate Okukhov length, 
-    CHARACTER (LEN=8)    ::  run_date                                     !< 
-    CHARACTER (LEN=8)    ::  run_time                                     !< 
-    CHARACTER (LEN=9)    ::  simulated_time_chr                           !< 
-    CHARACTER (LEN=11)   ::  topography_grid_convention = ' '             !< 
-    CHARACTER (LEN=12)   ::  version = ' '                                !< 
-    CHARACTER (LEN=12)   ::  revision = ' '                               !< 
-    CHARACTER (LEN=12)   ::  user_interface_current_revision = ' '        !< 
-    CHARACTER (LEN=12)   ::  user_interface_required_revision = ' '       !< 
-    CHARACTER (LEN=16)   ::  conserve_volume_flow_mode = 'default'        !< 
-    CHARACTER (LEN=16)   ::  loop_optimization = 'default'                !< 
-    CHARACTER (LEN=16)   ::  momentum_advec = 'ws-scheme'                 !< 
-    CHARACTER (LEN=16)   ::  psolver = 'poisfft'                          !<  
-    CHARACTER (LEN=16)   ::  scalar_advec = 'ws-scheme'                   !< 
-    CHARACTER (LEN=20)   ::  approximation = 'boussinesq'                 !<  
-    CHARACTER (LEN=40)   ::  flux_input_mode = 'approximation-specific'   !< 
-    CHARACTER (LEN=40)   ::  flux_output_mode = 'approximation-specific'  !< 
-    CHARACTER (LEN=20)   ::  bc_e_b = 'neumann'                           !< 
-    CHARACTER (LEN=20)   ::  bc_lr = 'cyclic'                             !< 
-    CHARACTER (LEN=20)   ::  bc_ns = 'cyclic'                             !< 
-    CHARACTER (LEN=20)   ::  bc_p_b = 'neumann'                           !< 
-    CHARACTER (LEN=20)   ::  bc_p_t = 'dirichlet'                         !< 
-    CHARACTER (LEN=20)   ::  bc_pt_b = 'dirichlet'                        !< 
-    CHARACTER (LEN=20)   ::  bc_pt_t = 'initial_gradient'                 !< 
-    CHARACTER (LEN=20)   ::  bc_q_b = 'dirichlet'                         !< 
-    CHARACTER (LEN=20)   ::  bc_q_t = 'neumann'                           !< 
-    CHARACTER (LEN=20)   ::  bc_s_b = 'dirichlet'                         !< 
-    CHARACTER (LEN=20)   ::  bc_s_t = 'initial_gradient'                  !< 
-    CHARACTER (LEN=20)   ::  bc_sa_t = 'neumann'                          !< 
-    CHARACTER (LEN=20)   ::  bc_uv_b = 'dirichlet'                        !< 
-    CHARACTER (LEN=20)   ::  bc_uv_t = 'dirichlet'                        !< 
-    CHARACTER (LEN=20)   ::  cloud_scheme = 'saturation_adjust'           !< 
-    CHARACTER (LEN=20)   ::  coupling_mode = 'uncoupled'                  !<    
-    CHARACTER (LEN=20)   ::  coupling_mode_remote = 'uncoupled'           !< 
-    CHARACTER (LEN=20)   ::  dissipation_1d = 'detering'                  !< 
-    CHARACTER (LEN=20)   ::  fft_method = 'system-specific'               !< 
-    CHARACTER (LEN=20)   ::  mixing_length_1d = 'blackadar'               !< 
-    CHARACTER (LEN=20)   ::  random_generator = 'random-parallel'         !< 
-    CHARACTER (LEN=20)   ::  reference_state = 'initial_profile'          !<   
-    CHARACTER (LEN=20)   ::  return_addres                                !< 
-    CHARACTER (LEN=20)   ::  return_username                              !< 
-    CHARACTER (LEN=20)   ::  timestep_scheme = 'runge-kutta-3'            !<        
-    CHARACTER (LEN=40)   ::  avs_data_file                                !< 
-    CHARACTER (LEN=40)   ::  topography = 'flat'                          !<  
-    CHARACTER (LEN=64)   ::  host = ' '                                   !< 
-    CHARACTER (LEN=80)   ::  log_message                                  !< 
-    CHARACTER (LEN=80)   ::  run_identifier                               !<  
-    CHARACTER (LEN=100)  ::  initializing_actions = ' '                   !< 
-    CHARACTER (LEN=210)  ::  run_description_header                       !< 
-    CHARACTER (LEN=1000) ::  message_string = ' '                         !< 
-
-    CHARACTER (LEN=varnamelength), DIMENSION(500) ::  data_output = ' '       !< 
-    CHARACTER (LEN=varnamelength), DIMENSION(500) ::  data_output_user = ' '  !< 
-    CHARACTER (LEN=varnamelength), DIMENSION(500) ::  doav = ' '              !<
+    CHARACTER (LEN=1)    ::  cycle_mg = 'w'                               !< namelist parameter (see documentation)
+    CHARACTER (LEN=1)    ::  timestep_reason = ' '                        !< 'A'dvection or 'D'iffusion criterion, written to RUN_CONTROL file
+    CHARACTER (LEN=3)    ::  coupling_char = ''                           !< Siggi
+    CHARACTER (LEN=5)    ::  write_binary = 'false'                       !< internal namelist parameter Siggi--> Why is this not a flag?
+    CHARACTER (LEN=8)    ::  most_method = 'newton'                       !< namelist parameter
+    CHARACTER (LEN=8)    ::  run_date                                     !< date of simulation run, printed to HEADER file
+    CHARACTER (LEN=8)    ::  run_time                                     !< time of simulation run, printed to HEADER file
+    CHARACTER (LEN=9)    ::  simulated_time_chr                           !< simulated time, printed to RUN_CONTROL file
+    CHARACTER (LEN=11)   ::  topography_grid_convention = ' '             !< namelist parameter
+    CHARACTER (LEN=12)   ::  version = ' '                                !< PALM version number
+    CHARACTER (LEN=12)   ::  revision = ' '                               !< PALM revision number
+    CHARACTER (LEN=12)   ::  user_interface_current_revision = ' '        !< Siggi
+    CHARACTER (LEN=12)   ::  user_interface_required_revision = ' '       !< Siggi
+    CHARACTER (LEN=16)   ::  conserve_volume_flow_mode = 'default'        !< namelist parameter
+    CHARACTER (LEN=16)   ::  loop_optimization = 'default'                !< namelist parameter
+    CHARACTER (LEN=16)   ::  momentum_advec = 'ws-scheme'                 !< namelist parameter
+    CHARACTER (LEN=16)   ::  psolver = 'poisfft'                          !< namelist parameter
+    CHARACTER (LEN=16)   ::  scalar_advec = 'ws-scheme'                   !< namelist parameter
+    CHARACTER (LEN=20)   ::  approximation = 'boussinesq'                 !< namelist parameter
+    CHARACTER (LEN=40)   ::  flux_input_mode = 'approximation-specific'   !< type of flux input: dynamic or kinematic
+    CHARACTER (LEN=40)   ::  flux_output_mode = 'approximation-specific'  !< type of flux output: dynamic or kinematic
+    CHARACTER (LEN=20)   ::  bc_e_b = 'neumann'                           !< namelist parameter
+    CHARACTER (LEN=20)   ::  bc_lr = 'cyclic'                             !< namelist parameter
+    CHARACTER (LEN=20)   ::  bc_ns = 'cyclic'                             !< namelist parameter
+    CHARACTER (LEN=20)   ::  bc_p_b = 'neumann'                           !< namelist parameter
+    CHARACTER (LEN=20)   ::  bc_p_t = 'dirichlet'                         !< namelist parameter
+    CHARACTER (LEN=20)   ::  bc_pt_b = 'dirichlet'                        !< namelist parameter
+    CHARACTER (LEN=20)   ::  bc_pt_t = 'initial_gradient'                 !< namelist parameter
+    CHARACTER (LEN=20)   ::  bc_q_b = 'dirichlet'                         !< namelist parameter
+    CHARACTER (LEN=20)   ::  bc_q_t = 'neumann'                           !< namelist parameter
+    CHARACTER (LEN=20)   ::  bc_s_b = 'dirichlet'                         !< namelist parameter
+    CHARACTER (LEN=20)   ::  bc_s_t = 'initial_gradient'                  !< namelist parameter
+    CHARACTER (LEN=20)   ::  bc_sa_t = 'neumann'                          !< namelist parameter
+    CHARACTER (LEN=20)   ::  bc_uv_b = 'dirichlet'                        !< namelist parameter
+    CHARACTER (LEN=20)   ::  bc_uv_t = 'dirichlet'                        !< namelist parameter
+    CHARACTER (LEN=20)   ::  cloud_scheme = 'saturation_adjust'           !< namelist parameter
+    CHARACTER (LEN=20)   ::  coupling_mode = 'uncoupled'                  !< coupling mode for atmosphere-ocean coupling  
+    CHARACTER (LEN=20)   ::  coupling_mode_remote = 'uncoupled'           !< Siggi
+    CHARACTER (LEN=20)   ::  dissipation_1d = 'detering'                  !< namelist parameter
+    CHARACTER (LEN=20)   ::  fft_method = 'system-specific'               !< namelist parameter
+    CHARACTER (LEN=20)   ::  mixing_length_1d = 'blackadar'               !< namelist parameter
+    CHARACTER (LEN=20)   ::  random_generator = 'random-parallel'         !< namelist parameter
+    CHARACTER (LEN=20)   ::  reference_state = 'initial_profile'          !< namelist parameter  
+    CHARACTER (LEN=20)   ::  return_addres                                !< Siggi
+    CHARACTER (LEN=20)   ::  return_username                              !< Siggi
+    CHARACTER (LEN=20)   ::  timestep_scheme = 'runge-kutta-3'            !< namelist parameter       
+    CHARACTER (LEN=40)   ::  avs_data_file                                !< Siggi
+    CHARACTER (LEN=40)   ::  topography = 'flat'                          !< namelist parameter 
+    CHARACTER (LEN=64)   ::  host = ' '                                   !< Siggi
+    CHARACTER (LEN=80)   ::  log_message                                  !< Siggi
+    CHARACTER (LEN=80)   ::  run_identifier                               !< Siggi
+    CHARACTER (LEN=100)  ::  initializing_actions = ' '                   !< namelist parameter
+    CHARACTER (LEN=210)  ::  run_description_header                       !< Siggi
+    CHARACTER (LEN=1000) ::  message_string = ' '                         !< dynamic string for error message output
+
+    CHARACTER (LEN=varnamelength), DIMENSION(500) ::  data_output = ' '       !< namelist parameter
+    CHARACTER (LEN=varnamelength), DIMENSION(500) ::  data_output_user = ' '  !< namelist parameter
+    CHARACTER (LEN=varnamelength), DIMENSION(500) ::  doav = ' '              !< label array for multi-dimensional, 
+                                                                              !< averaged output quantities
                                             
-    CHARACTER (LEN=varnamelength), DIMENSION(max_masks,100) ::  data_output_masks = ' '       !< 
-    CHARACTER (LEN=varnamelength), DIMENSION(max_masks,100) ::  data_output_masks_user = ' '  !< 
-
-    CHARACTER (LEN=varnamelength), DIMENSION(300) ::  data_output_pr = ' '  !< 
+    CHARACTER (LEN=varnamelength), DIMENSION(max_masks,100) ::  data_output_masks = ' '       !< namelist parameter
+    CHARACTER (LEN=varnamelength), DIMENSION(max_masks,100) ::  data_output_masks_user = ' '  !< namelist parameter
+
+    CHARACTER (LEN=varnamelength), DIMENSION(300) ::  data_output_pr = ' '  !< namelist parameter
     
-    CHARACTER (LEN=varnamelength), DIMENSION(200) ::  data_output_pr_user = ' '  !< 
+    CHARACTER (LEN=varnamelength), DIMENSION(200) ::  data_output_pr_user = ' '  !< namelist parameter
     
-    CHARACTER (LEN=varnamelength), DIMENSION(max_masks,0:1,100) ::  domask = ' ' !< 
+    CHARACTER (LEN=varnamelength), DIMENSION(max_masks,0:1,100) ::  domask = ' ' !< label array for multi-dimensional, 
+                                                                                 !< masked output quantities
     
-    CHARACTER (LEN=varnamelength), DIMENSION(0:1,500) ::  do2d = ' '  !< 
-    CHARACTER (LEN=varnamelength), DIMENSION(0:1,500) ::  do3d = ' '  !< 
-
-    INTEGER(iwp), PARAMETER ::  fl_max = 100     !< 
-    INTEGER(iwp), PARAMETER ::  var_fl_max = 20  !< 
+    CHARACTER (LEN=varnamelength), DIMENSION(0:1,500) ::  do2d = ' '  !< label array for 2d output quantities
+    CHARACTER (LEN=varnamelength), DIMENSION(0:1,500) ::  do3d = ' '  !< label array for 3d output quantities
+
+    INTEGER(iwp), PARAMETER ::  fl_max = 100     !< maximum number of virtual-flight measurements
+    INTEGER(iwp), PARAMETER ::  var_fl_max = 20  !< maximum number of different sampling variables in virtual flight measurements
     
-    INTEGER(iwp) ::  abort_mode = 1                    !< 
-    INTEGER(iwp) ::  average_count_pr = 0              !< 
-    INTEGER(iwp) ::  average_count_3d = 0              !< 
-    INTEGER(iwp) ::  current_timestep_number = 0       !< 
-    INTEGER(iwp) ::  coupling_topology = 0             !< 
-    INTEGER(iwp) ::  dist_range = 0                    !< 
-    INTEGER(iwp) ::  disturbance_level_ind_b           !< 
-    INTEGER(iwp) ::  disturbance_level_ind_t           !< 
-    INTEGER(iwp) ::  doav_n = 0                        !< 
-    INTEGER(iwp) ::  dopr_n = 0                        !< 
-    INTEGER(iwp) ::  dopr_time_count = 0               !< 
-    INTEGER(iwp) ::  dopts_time_count = 0              !< 
-    INTEGER(iwp) ::  dots_time_count = 0               !< 
-    INTEGER(iwp) ::  do2d_xy_n = 0                     !< 
-    INTEGER(iwp) ::  do2d_xz_n = 0                     !< 
-    INTEGER(iwp) ::  do2d_yz_n = 0                     !< 
-    INTEGER(iwp) ::  do3d_avs_n = 0                    !< 
-    INTEGER(iwp) ::  dp_level_ind_b = 0                !< 
-    INTEGER(iwp) ::  dvrp_filecount = 0                !< 
-    INTEGER(iwp) ::  dz_stretch_level_index            !< 
-    INTEGER(iwp) ::  ensemble_member_nr = 0            !< 
-    INTEGER(iwp) ::  gamma_mg                          !< 
-    INTEGER(iwp) ::  gathered_size                     !< 
-    INTEGER(iwp) ::  grid_level                        !< 
-    INTEGER(iwp) ::  ibc_e_b                           !< 
-    INTEGER(iwp) ::  ibc_p_b                           !< 
-    INTEGER(iwp) ::  ibc_p_t                           !< 
-    INTEGER(iwp) ::  ibc_pt_b                          !< 
-    INTEGER(iwp) ::  ibc_pt_t                          !< 
-    INTEGER(iwp) ::  ibc_q_b                           !< 
-    INTEGER(iwp) ::  ibc_q_t                           !< 
-    INTEGER(iwp) ::  ibc_s_b                           !< 
-    INTEGER(iwp) ::  ibc_s_t                           !< 
-    INTEGER(iwp) ::  ibc_sa_t                          !< 
-    INTEGER(iwp) ::  ibc_uv_b                          !< 
-    INTEGER(iwp) ::  ibc_uv_t                          !< 
-    INTEGER(iwp) ::  inflow_disturbance_begin = -1     !< 
-    INTEGER(iwp) ::  inflow_disturbance_end = -1       !< 
-    INTEGER(iwp) ::  intermediate_timestep_count       !< 
-    INTEGER(iwp) ::  intermediate_timestep_count_max   !< 
-    INTEGER(iwp) ::  io_group = 0                      !< 
-    INTEGER(iwp) ::  io_blocks = 1                     !< 
-    INTEGER(iwp) ::  iran = -1234567                   !< 
+    INTEGER(iwp) ::  abort_mode = 1                    !< abort condition (nested runs)
+    INTEGER(iwp) ::  average_count_pr = 0              !< number of samples in vertical-profile output
+    INTEGER(iwp) ::  average_count_3d = 0              !< number of samples in 3d output
+    INTEGER(iwp) ::  current_timestep_number = 0       !< current timestep number, printed to RUN_CONTROL file
+    INTEGER(iwp) ::  coupling_topology = 0             !< processor topology for atmosphere-ocean coupling  Siggi
+    INTEGER(iwp) ::  dist_range = 0                    !< Siggi
+    INTEGER(iwp) ::  disturbance_level_ind_b           !< lowest grid index where flow disturbance is applied
+    INTEGER(iwp) ::  disturbance_level_ind_t           !< highest grid index where flow disturbance is applied
+    INTEGER(iwp) ::  doav_n = 0                        !< number of 2d/3d output quantities subject to time averaging
+    INTEGER(iwp) ::  dopr_n = 0                        !< number of profile output quantities subject to time averaging
+    INTEGER(iwp) ::  dopr_time_count = 0               !< number of output intervals for profile output
+    INTEGER(iwp) ::  dopts_time_count = 0              !< number of output intervals for particle data timeseries
+    INTEGER(iwp) ::  dots_time_count = 0               !< number of output intervals for timeseries output
+    INTEGER(iwp) ::  dp_level_ind_b = 0                !< lowest grid index for external pressure gradient forcing
+    INTEGER(iwp) ::  dvrp_filecount = 0                !< Siggi
+    INTEGER(iwp) ::  dz_stretch_level_index            !< Siggi
+    INTEGER(iwp) ::  ensemble_member_nr = 0            !< namelist parameter
+    INTEGER(iwp) ::  gamma_mg                          !< Siggi
+    INTEGER(iwp) ::  gathered_size                     !< Siggi
+    INTEGER(iwp) ::  grid_level                        !< Siggi
+    INTEGER(iwp) ::  ibc_e_b                           !< integer flag for bc_e_b
+    INTEGER(iwp) ::  ibc_p_b                           !< integer flag for bc_p_b
+    INTEGER(iwp) ::  ibc_p_t                           !< integer flag for bc_p_t
+    INTEGER(iwp) ::  ibc_pt_b                          !< integer flag for bc_pt_b
+    INTEGER(iwp) ::  ibc_pt_t                          !< integer flag for bc_pt_t
+    INTEGER(iwp) ::  ibc_q_b                           !< integer flag for bc_q_b
+    INTEGER(iwp) ::  ibc_q_t                           !< integer flag for bc_q_t
+    INTEGER(iwp) ::  ibc_s_b                           !< integer flag for bc_s_b
+    INTEGER(iwp) ::  ibc_s_t                           !< integer flag for bc_s_t
+    INTEGER(iwp) ::  ibc_sa_t                          !< integer flag for bc_sa_t
+    INTEGER(iwp) ::  ibc_uv_b                          !< integer flag for bc_uv_b
+    INTEGER(iwp) ::  ibc_uv_t                          !< integer flag for bc_uv_t
+    INTEGER(iwp) ::  inflow_disturbance_begin = -1     !< namelist parameter
+    INTEGER(iwp) ::  inflow_disturbance_end = -1       !< namelist parameter
+    INTEGER(iwp) ::  intermediate_timestep_count       !< number of current Runge-Kutta substep
+    INTEGER(iwp) ::  intermediate_timestep_count_max   !< maximum number of Runge-Kutta substeps
+    INTEGER(iwp) ::  io_group = 0                      !< Siggi
+    INTEGER(iwp) ::  io_blocks = 1                     !< Siggi
+    INTEGER(iwp) ::  iran = -1234567                   !< integer random number used for flow disturbances
     INTEGER(iwp) ::  lod = 1                           !< level of detail, topography input parameter 
-    INTEGER(iwp) ::  masks = 0                         !< 
-    INTEGER(iwp) ::  maximum_grid_level                !< 
-    INTEGER(iwp) ::  maximum_parallel_io_streams = -1  !< 
-    INTEGER(iwp) ::  max_pr_user = 0                   !< 
-    INTEGER(iwp) ::  mgcycles = 0                      !< 
-    INTEGER(iwp) ::  mg_cycles = -1                    !< 
-    INTEGER(iwp) ::  mg_switch_to_pe0_level = -1       !< 
-    INTEGER(iwp) ::  mid                               !< 
-    INTEGER(iwp) ::  nlsf = 1000                       !< 
-    INTEGER(iwp) ::  ntnudge = 1000                    !< 
-    INTEGER(iwp) ::  ngsrb = 2                         !< 
-    INTEGER(iwp) ::  nr_timesteps_this_run = 0         !< 
-    INTEGER(iwp) ::  nsor = 20                         !< 
-    INTEGER(iwp) ::  nsor_ini = 100                    !< 
-    INTEGER(iwp) ::  n_sor                             !< 
-    INTEGER(iwp) ::  normalizing_region = 0            !< 
-    INTEGER(iwp) ::  num_leg=0                         !< 
-    INTEGER(iwp) ::  num_var_fl                        !< 
-    INTEGER(iwp) ::  num_var_fl_user=0                 !< 
-    INTEGER(iwp) ::  nz_do3d = -9999                   !< 
-    INTEGER(iwp) ::  prt_time_count = 0                !< 
-    INTEGER(iwp) ::  recycling_plane                   !< 
-    INTEGER(iwp) ::  runnr = 0                         !< 
-    INTEGER(iwp) ::  skip_do_avs = 0                   !< 
-    INTEGER(iwp) ::  subdomain_size                    !< 
-    INTEGER(iwp) ::  terminate_coupled = 0             !< 
-    INTEGER(iwp) ::  terminate_coupled_remote = 0      !< 
-    INTEGER(iwp) ::  timestep_count = 0                !< 
-
-    INTEGER(iwp) ::  dist_nxl(0:1)                               !< 
-    INTEGER(iwp) ::  dist_nxr(0:1)                               !< 
-    INTEGER(iwp) ::  dist_nyn(0:1)                               !< 
-    INTEGER(iwp) ::  dist_nys(0:1)                               !< 
-    INTEGER(iwp) ::  do2d_no(0:1) = 0                            !< 
-    INTEGER(iwp) ::  do2d_xy_time_count(0:1)                     !< 
-    INTEGER(iwp) ::  do2d_xz_time_count(0:1)                     !< 
-    INTEGER(iwp) ::  do2d_yz_time_count(0:1)                     !< 
-    INTEGER(iwp) ::  do3d_no(0:1) = 0                            !< 
-    INTEGER(iwp) ::  do3d_time_count(0:1)                        !< 
-    INTEGER(iwp) ::  domask_no(max_masks,0:1) = 0                !< 
-    INTEGER(iwp) ::  domask_time_count(max_masks,0:1)            !< 
-    INTEGER(iwp) ::  mask_size(max_masks,3) = -1                 !< 
-    INTEGER(iwp) ::  mask_size_l(max_masks,3) = -1               !< 
-    INTEGER(iwp) ::  mask_start_l(max_masks,3) = -1              !< 
-    INTEGER(iwp) ::  pt_vertical_gradient_level_ind(10) = -9999  !< 
-    INTEGER(iwp) ::  q_vertical_gradient_level_ind(10) = -9999   !< 
-    INTEGER(iwp) ::  s_vertical_gradient_level_ind(10) = -9999   !<                
-    INTEGER(iwp) ::  sa_vertical_gradient_level_ind(10) = -9999  !< 
-    INTEGER(iwp) ::  section(100,3)                              !< 
-    INTEGER(iwp) ::  section_xy(100) = -9999                     !< 
-    INTEGER(iwp) ::  section_xz(100) = -9999                     !< 
-    INTEGER(iwp) ::  section_yz(100) = -9999                     !< 
-    INTEGER(iwp) ::  ug_vertical_gradient_level_ind(10) = -9999  !< 
-    INTEGER(iwp) ::  vg_vertical_gradient_level_ind(10) = -9999  !< 
-    INTEGER(iwp) ::  subs_vertical_gradient_level_i(10) = -9999  !< 
-
-
-    INTEGER(iwp), DIMENSION(0:1) ::  ntdim_2d_xy  !< 
-    INTEGER(iwp), DIMENSION(0:1) ::  ntdim_2d_xz  !< 
-    INTEGER(iwp), DIMENSION(0:1) ::  ntdim_2d_yz  !< 
-    INTEGER(iwp), DIMENSION(0:1) ::  ntdim_3d     !< 
-
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  grid_level_count  !< 
-
-    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  mask_i         !< 
-    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  mask_j         !< 
-    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  mask_k         !< 
-    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  mask_i_global  !<   
-    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  mask_j_global  !< 
-    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  mask_k_global  !< 
-
-    LOGICAL ::  bc_lr_cyc =.TRUE.                            !< 
-    LOGICAL ::  bc_lr_dirrad = .FALSE.                       !< 
-    LOGICAL ::  bc_lr_raddir = .FALSE.                       !< 
-    LOGICAL ::  bc_ns_cyc = .TRUE.                           !< 
-    LOGICAL ::  bc_ns_dirrad = .FALSE.                       !< 
-    LOGICAL ::  bc_ns_raddir = .FALSE.                       !< 
-    LOGICAL ::  call_microphysics_at_all_substeps = .FALSE.  !< 
-    LOGICAL ::  call_psolver_at_all_substeps = .TRUE.        !< 
-    LOGICAL ::  cloud_droplets = .FALSE.                     !< 
-    LOGICAL ::  cloud_physics = .FALSE.                      !< 
-    LOGICAL ::  cloud_top_radiation = .FALSE.                !< 
-    LOGICAL ::  conserve_volume_flow = .FALSE.               !< 
-    LOGICAL ::  constant_diffusion = .FALSE.                 !< 
-    LOGICAL ::  constant_flux_layer = .TRUE.                 !< 
-    LOGICAL ::  constant_heatflux = .TRUE.                   !<  
-    LOGICAL ::  constant_top_heatflux = .TRUE.               !< 
-    LOGICAL ::  constant_top_momentumflux = .FALSE.          !< 
-    LOGICAL ::  constant_top_salinityflux = .TRUE.           !< 
-    LOGICAL ::  constant_top_scalarflux = .TRUE.             !< 
-    LOGICAL ::  constant_scalarflux = .TRUE.                 !< 
-    LOGICAL ::  constant_waterflux = .TRUE.                  !< 
-    LOGICAL ::  create_disturbances = .TRUE.                 !< 
-    LOGICAL ::  data_output_2d_on_each_pe = .TRUE.           !< 
-    LOGICAL ::  dissipation_control = .FALSE.                !< 
-    LOGICAL ::  disturbance_created = .FALSE.                !< 
-    LOGICAL ::  do2d_at_begin = .FALSE.                      !< 
-    LOGICAL ::  do3d_at_begin = .FALSE.                      !< 
-    LOGICAL ::  do_sum = .FALSE.                             !< 
-    LOGICAL ::  dp_external = .FALSE.                        !< 
-    LOGICAL ::  dp_smooth = .FALSE.                          !< 
-    LOGICAL ::  dt_fixed = .FALSE.                           !< 
-    LOGICAL ::  dt_3d_reached                                !< 
-    LOGICAL ::  dt_3d_reached_l                              !< 
-    LOGICAL ::  exchange_mg = .FALSE.                        !< 
-    LOGICAL ::  first_call_lpm = .TRUE.                      !< 
-    LOGICAL ::  force_print_header = .FALSE.                 !< 
-    LOGICAL ::  galilei_transformation = .FALSE.             !< 
-    LOGICAL ::  humidity = .FALSE.                           !< 
-    LOGICAL ::  humidity_remote = .FALSE.                    !< 
-    LOGICAL ::  inflow_l = .FALSE.                           !< 
-    LOGICAL ::  inflow_n = .FALSE.                           !< 
-    LOGICAL ::  inflow_r = .FALSE.                           !< 
-    LOGICAL ::  inflow_s = .FALSE.                           !< 
-    LOGICAL ::  large_scale_forcing = .FALSE.                !< 
-    LOGICAL ::  large_scale_subsidence = .FALSE.             !< 
-    LOGICAL ::  land_surface = .FALSE.                       !< flag parameter indicating wheather the lsm is used
-    LOGICAL ::  lsf_exception = .FALSE.                      !< temporary flag for use of lsf with buildings on flat terrain
-    LOGICAL ::  lsf_surf = .TRUE.                            !< 
-    LOGICAL ::  lsf_vert = .TRUE.                            !< 
-    LOGICAL ::  lptnudge = .FALSE.                           !< 
-    LOGICAL ::  lqnudge = .FALSE.                            !< 
-    LOGICAL ::  lunudge = .FALSE.                            !< 
-    LOGICAL ::  lvnudge = .FALSE.                            !< 
-    LOGICAL ::  lwnudge = .FALSE.                            !< 
-    LOGICAL ::  masking_method = .FALSE.                     !< 
-    LOGICAL ::  microphysics_sat_adjust = .FALSE.            !< 
-    LOGICAL ::  microphysics_kessler = .FALSE.               !< 
-    LOGICAL ::  microphysics_seifert = .FALSE.               !< 
-    LOGICAL ::  mg_switch_to_pe0 = .FALSE.                   !< 
-    LOGICAL ::  nest_bound_l = .FALSE.                       !< nested boundary on left side
-    LOGICAL ::  nest_bound_n = .FALSE.                       !< nested boundary on north side
-    LOGICAL ::  nest_bound_r = .FALSE.                       !< nested boundary on right side
-    LOGICAL ::  nest_bound_s = .FALSE.                       !< nested boundary on south side
-    LOGICAL ::  nest_domain  = .FALSE.                       !< domain is nested into a parent domain
-    LOGICAL ::  neutral = .FALSE.                            !< 
-    LOGICAL ::  nudging = .FALSE.                            !< 
-    LOGICAL ::  ocean = .FALSE.                              !< 
-    LOGICAL ::  outflow_l = .FALSE.                          !< 
-    LOGICAL ::  outflow_n = .FALSE.                          !< 
-    LOGICAL ::  outflow_r = .FALSE.                          !< 
-    LOGICAL ::  outflow_s = .FALSE.                          !< 
-    LOGICAL ::  passive_scalar = .FALSE.                     !< 
-    LOGICAL ::  precipitation = .FALSE.                      !< 
-    LOGICAL ::  random_heatflux = .FALSE.                    !< 
-    LOGICAL ::  recycling_yshift = .FALSE.                   !< 
-    LOGICAL ::  run_control_header = .FALSE.                 !< 
-    LOGICAL ::  run_coupled = .TRUE.                         !< 
-    LOGICAL ::  scalar_rayleigh_damping = .TRUE.             !< 
-    LOGICAL ::  sloping_surface = .FALSE.                    !< 
-    LOGICAL ::  stop_dt = .FALSE.                            !< 
-    LOGICAL ::  synchronous_exchange = .FALSE.               !< 
+    INTEGER(iwp) ::  masks = 0                         !< counter for number of masked output quantities
+    INTEGER(iwp) ::  maximum_grid_level                !< Siggi
+    INTEGER(iwp) ::  maximum_parallel_io_streams = -1  !< Siggi
+    INTEGER(iwp) ::  max_pr_user = 0                   !< number of user-defined profiles (must not change within a job chain)
+    INTEGER(iwp) ::  mgcycles = 0                      !< Siggi
+    INTEGER(iwp) ::  mg_cycles = -1                    !< namelist parameter
+    INTEGER(iwp) ::  mg_switch_to_pe0_level = -1       !< namelist parameter
+    INTEGER(iwp) ::  mid                               !< masked output running index
+    INTEGER(iwp) ::  nlsf = 1000                       !< maximum number of profiles in LSF_DATA (large scale forcing)
+    INTEGER(iwp) ::  ntnudge = 1000                    !< maximum number of profiles in NUDGING_DATA (nudging)
+    INTEGER(iwp) ::  ngsrb = 2                         !< namelist parameter
+    INTEGER(iwp) ::  nr_timesteps_this_run = 0         !< number of timesteps (cpu time measurements)
+    INTEGER(iwp) ::  nsor = 20                         !< namelist parameter
+    INTEGER(iwp) ::  nsor_ini = 100                    !< namelist parameter
+    INTEGER(iwp) ::  n_sor                             !< number of iterations to be used in SOR-scheme
+    INTEGER(iwp) ::  normalizing_region = 0            !< namelist parameter
+    INTEGER(iwp) ::  num_leg=0                         !< number of different legs in virtual flight measurements
+    INTEGER(iwp) ::  num_var_fl                        !< number of sampling/output variables in virtual flight measurements
+    INTEGER(iwp) ::  num_var_fl_user=0                 !< number of user-defined sampling/output variables in virtual flight measurements
+    INTEGER(iwp) ::  nz_do3d = -9999                   !< namelist parameter
+    INTEGER(iwp) ::  prt_time_count = 0                !< number of output intervals for particle data output
+    INTEGER(iwp) ::  recycling_plane                   !< position of recycling plane along x (in grid points) in case of turbulence recycling
+    INTEGER(iwp) ::  runnr = 0                         !< number of run in job chain
+    INTEGER(iwp) ::  subdomain_size                    !< number of grid points in (3d) subdomain including ghost points
+    INTEGER(iwp) ::  terminate_coupled = 0             !< Siggi
+    INTEGER(iwp) ::  terminate_coupled_remote = 0      !< Siggi
+    INTEGER(iwp) ::  timestep_count = 0                !< Siggi --> is it not analogue to intermediate_timestep_count
+    INTEGER(iwp) ::  dist_nxl(0:1)                               !< left boundary of disturbance region
+    INTEGER(iwp) ::  dist_nxr(0:1)                               !< right boundary of disturbance region
+    INTEGER(iwp) ::  dist_nyn(0:1)                               !< north boundary of disturbance region
+    INTEGER(iwp) ::  dist_nys(0:1)                               !< south boundary of disturbance region
+    INTEGER(iwp) ::  do2d_no(0:1) = 0                            !< number of 2d output quantities
+    INTEGER(iwp) ::  do2d_xy_time_count(0:1)                     !< number of output intervals for 2d data (xy)
+    INTEGER(iwp) ::  do2d_xz_time_count(0:1)                     !< number of output intervals for 2d data (xz)
+    INTEGER(iwp) ::  do2d_yz_time_count(0:1)                     !< number of output intervals for 2d data (yz)
+    INTEGER(iwp) ::  do3d_no(0:1) = 0                            !< number of 3d output quantities
+    INTEGER(iwp) ::  do3d_time_count(0:1)                        !< number of output intervals for 3d data
+    INTEGER(iwp) ::  domask_no(max_masks,0:1) = 0                !< number of masked output quantities
+    INTEGER(iwp) ::  domask_time_count(max_masks,0:1)            !< number of output intervals for masked data
+    INTEGER(iwp) ::  mask_size(max_masks,3) = -1                 !< size of mask array per mask and dimension (for netcdf output)
+    INTEGER(iwp) ::  mask_size_l(max_masks,3) = -1               !< subdomain size of mask array per mask and dimension (for netcdf output)
+    INTEGER(iwp) ::  mask_start_l(max_masks,3) = -1              !< subdomain start index of mask array (for netcdf output)
+    INTEGER(iwp) ::  pt_vertical_gradient_level_ind(10) = -9999  !< grid index values of pt_vertical_gradient_level(s)
+    INTEGER(iwp) ::  q_vertical_gradient_level_ind(10) = -9999   !< grid index values of q_vertical_gradient_level(s)
+    INTEGER(iwp) ::  s_vertical_gradient_level_ind(10) = -9999   !< grid index values of s_vertical_gradient_level(s)   
+    INTEGER(iwp) ::  sa_vertical_gradient_level_ind(10) = -9999  !< grid index values of sa_vertical_gradient_level(s)
+    INTEGER(iwp) ::  section(100,3)                              !< collective array for section_xy/xz/yz
+    INTEGER(iwp) ::  section_xy(100) = -9999                     !< namelist parameter
+    INTEGER(iwp) ::  section_xz(100) = -9999                     !< namelist parameter
+    INTEGER(iwp) ::  section_yz(100) = -9999                     !< namelist parameter
+    INTEGER(iwp) ::  ug_vertical_gradient_level_ind(10) = -9999  !< grid index values of ug_vertical_gradient_level(s)
+    INTEGER(iwp) ::  vg_vertical_gradient_level_ind(10) = -9999  !< grid index values of vg_vertical_gradient_level(s)
+    INTEGER(iwp) ::  subs_vertical_gradient_level_i(10) = -9999  !< grid index values of subs_vertical_gradient_level(s)
+
+    INTEGER(iwp), DIMENSION(0:1) ::  ntdim_2d_xy  !< number of output intervals for 2d data (xy)
+    INTEGER(iwp), DIMENSION(0:1) ::  ntdim_2d_xz  !< number of output intervals for 2d data (xz)
+    INTEGER(iwp), DIMENSION(0:1) ::  ntdim_2d_yz  !< number of output intervals for 2d data (yz)
+    INTEGER(iwp), DIMENSION(0:1) ::  ntdim_3d     !< number of output intervals for 3d data
+
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  grid_level_count  !< Siggi
+
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  mask_i         !< subdomain grid index of masked output point on x-dimension
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  mask_j         !< subdomain grid index of masked output point on y-dimension
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  mask_k         !< subdomain grid index of masked output point on z-dimension
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  mask_i_global  !< global grid index of masked output point on x-dimension
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  mask_j_global  !< global grid index of masked output point on y-dimension
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  mask_k_global  !< global grid index of masked output point on z-dimension
+
+    LOGICAL ::  bc_lr_cyc =.TRUE.                            !< left-right boundary condition cyclic?
+    LOGICAL ::  bc_lr_dirrad = .FALSE.                       !< left-right boundary condition dirichlet/radiation?
+    LOGICAL ::  bc_lr_raddir = .FALSE.                       !< left-right boundary condition radiation/dirichlet?
+    LOGICAL ::  bc_ns_cyc = .TRUE.                           !< north-south boundary condition cyclic?
+    LOGICAL ::  bc_ns_dirrad = .FALSE.                       !< north-south boundary condition dirichlet/radiation?
+    LOGICAL ::  bc_ns_raddir = .FALSE.                       !< north-south boundary condition radiation/dirichlet?
+    LOGICAL ::  call_microphysics_at_all_substeps = .FALSE.  !< namelist parameter
+    LOGICAL ::  call_psolver_at_all_substeps = .TRUE.        !< namelist parameter
+    LOGICAL ::  cloud_droplets = .FALSE.                     !< namelist parameter
+    LOGICAL ::  cloud_physics = .FALSE.                      !< namelist parameter
+    LOGICAL ::  cloud_top_radiation = .FALSE.                !< namelist parameter
+    LOGICAL ::  conserve_volume_flow = .FALSE.               !< namelist parameter
+    LOGICAL ::  constant_diffusion = .FALSE.                 !< diffusion coefficient constant?
+    LOGICAL ::  constant_flux_layer = .TRUE.                 !< namelist parameter
+    LOGICAL ::  constant_heatflux = .TRUE.                   !< heat flux at all surfaces constant?
+    LOGICAL ::  constant_top_heatflux = .TRUE.               !< heat flux at domain top constant?
+    LOGICAL ::  constant_top_momentumflux = .FALSE.          !< momentum flux at domain topconstant?
+    LOGICAL ::  constant_top_salinityflux = .TRUE.           !< salinity flux at ocean domain top?
+    LOGICAL ::  constant_top_scalarflux = .TRUE.             !< passive-scalar flux at domain top constant?
+    LOGICAL ::  constant_scalarflux = .TRUE.                 !< passive-scalar flux at surfaces constant?
+    LOGICAL ::  constant_waterflux = .TRUE.                  !< water flux at all surfaces constant?
+    LOGICAL ::  create_disturbances = .TRUE.                 !< namelist parameter
+    LOGICAL ::  data_output_2d_on_each_pe = .TRUE.           !< namelist parameter
+    LOGICAL ::  disturbance_created = .FALSE.                !< flow disturbance imposed?
+    LOGICAL ::  do2d_at_begin = .FALSE.                      !< namelist parameter
+    LOGICAL ::  do3d_at_begin = .FALSE.                      !< namelist parameter
+    LOGICAL ::  do_sum = .FALSE.                             !< contribute to time average of profile data?
+    LOGICAL ::  dp_external = .FALSE.                        !< namelist parameter
+    LOGICAL ::  dp_smooth = .FALSE.                          !< namelist parameter
+    LOGICAL ::  dt_fixed = .FALSE.                           !< fixed timestep (namelist parameter dt set)?
+    LOGICAL ::  dt_3d_reached                                !< internal timestep for particle advection
+    LOGICAL ::  dt_3d_reached_l                              !< internal timestep for particle advection
+    LOGICAL ::  exchange_mg = .FALSE.                        !< (Siggi add short description) 
+    LOGICAL ::  first_call_lpm = .TRUE.                      !< call lpm only once per timestep?
+    LOGICAL ::  force_print_header = .FALSE.                 !< namelist parameter
+    LOGICAL ::  galilei_transformation = .FALSE.             !< namelist parameter
+    LOGICAL ::  humidity = .FALSE.                           !< namelist parameter
+    LOGICAL ::  humidity_remote = .FALSE.                    !< (Siggi add short description)
+    LOGICAL ::  inflow_l = .FALSE.                           !< left domain boundary has non-cyclic inflow?
+    LOGICAL ::  inflow_n = .FALSE.                           !< north domain boundary has non-cyclic inflow?
+    LOGICAL ::  inflow_r = .FALSE.                           !< right domain boundary has non-cyclic inflow?
+    LOGICAL ::  inflow_s = .FALSE.                           !< south domain boundary has non-cyclic inflow?
+    LOGICAL ::  large_scale_forcing = .FALSE.                !< namelist parameter
+    LOGICAL ::  large_scale_subsidence = .FALSE.             !< namelist parameter
+    LOGICAL ::  land_surface = .FALSE.                       !< use land surface model?
+    LOGICAL ::  lsf_exception = .FALSE.                      !< use of lsf with buildings (temporary)?
+    LOGICAL ::  lsf_surf = .TRUE.                            !< use surface forcing (large scale forcing)?
+    LOGICAL ::  lsf_vert = .TRUE.                            !< use atmospheric forcing (large scale forcing)?
+    LOGICAL ::  masking_method = .FALSE.                     !< namelist parameter
+    LOGICAL ::  microphysics_sat_adjust = .FALSE.            !< use saturation adjust bulk scheme?
+    LOGICAL ::  microphysics_kessler = .FALSE.               !< use kessler bulk scheme?
+    LOGICAL ::  microphysics_seifert = .FALSE.               !< use 2-moment Seifert and Beheng scheme?
+    LOGICAL ::  mg_switch_to_pe0 = .FALSE.                   !< (Siggi add short description)
+    LOGICAL ::  nest_bound_l = .FALSE.                       !< nested boundary on left side?
+    LOGICAL ::  nest_bound_n = .FALSE.                       !< nested boundary on north side?
+    LOGICAL ::  nest_bound_r = .FALSE.                       !< nested boundary on right side?
+    LOGICAL ::  nest_bound_s = .FALSE.                       !< nested boundary on south side?
+    LOGICAL ::  nest_domain  = .FALSE.                       !< domain is nested into a parent domain?
+    LOGICAL ::  neutral = .FALSE.                            !< namelist parameter
+    LOGICAL ::  nudging = .FALSE.                            !< namelist parameter
+    LOGICAL ::  ocean = .FALSE.                              !< namelist parameter
+    LOGICAL ::  outflow_l = .FALSE.                          !< left domain boundary has non-cyclic outflow?
+    LOGICAL ::  outflow_n = .FALSE.                          !< north domain boundary has non-cyclic outflow?
+    LOGICAL ::  outflow_r = .FALSE.                          !< right domain boundary has non-cyclic outflow?
+    LOGICAL ::  outflow_s = .FALSE.                          !< south domain boundary has non-cyclic outflow?
+    LOGICAL ::  passive_scalar = .FALSE.                     !< namelist parameter
+    LOGICAL ::  precipitation = .FALSE.                      !< namelist parameter
+    LOGICAL ::  random_heatflux = .FALSE.                    !< namelist parameter
+    LOGICAL ::  recycling_yshift = .FALSE.                   !< namelist parameter
+    LOGICAL ::  run_control_header = .FALSE.                 !< onetime output of RUN_CONTROL header
+    LOGICAL ::  run_coupled = .TRUE.                         !< (Siggi add short description)
+    LOGICAL ::  scalar_rayleigh_damping = .TRUE.             !< namelist parameter
+    LOGICAL ::  sloping_surface = .FALSE.                    !< use sloped surface?
+                                                             !< (namelist parameter alpha_surface)
+    LOGICAL ::  stop_dt = .FALSE.                            !< (Siggi add short description)
+    LOGICAL ::  synchronous_exchange = .FALSE.               !< namelist parameter
     LOGICAL ::  synthetic_turbulence_generator = .FALSE.     !< flag for synthetic turbulence generator module
-    LOGICAL ::  terminate_run = .FALSE.                      !< 
-    LOGICAL ::  transpose_compute_overlap = .FALSE.          !< 
-    LOGICAL ::  turbulent_inflow = .FALSE.                   !< 
-    LOGICAL ::  turbulent_outflow = .FALSE.                  !< flag for turbulent outflow condition
-    LOGICAL ::  urban_surface = .FALSE.                      !< flag for urban surface model
-    LOGICAL ::  use_cmax = .TRUE.                            !< 
-    LOGICAL ::  use_initial_profile_as_reference = .FALSE.   !< 
-    LOGICAL ::  use_prescribed_profile_data = .FALSE.        !< 
-    LOGICAL ::  use_single_reference_value = .FALSE.         !< 
-    LOGICAL ::  use_subsidence_tendencies = .FALSE.          !< 
-    LOGICAL ::  use_surface_fluxes = .FALSE.                 !< 
-    LOGICAL ::  use_top_fluxes = .FALSE.                     !< 
-    LOGICAL ::  use_ug_for_galilei_tr = .TRUE.               !< 
-    LOGICAL ::  use_upstream_for_tke = .FALSE.               !< 
-    LOGICAL ::  virtual_flight = .FALSE.                     !< flag for virtual flight model
-    LOGICAL ::  wall_adjustment = .TRUE.                     !< 
-    LOGICAL ::  ws_scheme_sca = .FALSE.                      !< 
-    LOGICAL ::  ws_scheme_mom = .FALSE.                      !< 
-    LOGICAL ::  data_output_xy(0:1) = .FALSE.                !< 
-    LOGICAL ::  data_output_xz(0:1) = .FALSE.                !< 
-    LOGICAL ::  data_output_yz(0:1) = .FALSE.                !< 
-
-    REAL(wp) ::  advected_distance_x = 0.0_wp                  !< 
-    REAL(wp) ::  advected_distance_y = 0.0_wp                  !< 
-    REAL(wp) ::  alpha_surface = 0.0_wp                        !< 
-    REAL(wp) ::  atmos_ocean_sign = 1.0_wp                     !< 
-    REAL(wp) ::  averaging_interval = 0.0_wp                   !< 
-    REAL(wp) ::  averaging_interval_pr = 9999999.9_wp          !< 
-    REAL(wp) ::  bc_pt_t_val                                   !< 
-    REAL(wp) ::  bc_q_t_val                                    !< 
-    REAL(wp) ::  bc_s_t_val                                    !< 
-    REAL(wp) ::  bottom_salinityflux = 0.0_wp                  !< 
-    REAL(wp) ::  building_height = 50.0_wp                     !< 
-    REAL(wp) ::  building_length_x = 50.0_wp                   !< 
-    REAL(wp) ::  building_length_y = 50.0_wp                   !< 
-    REAL(wp) ::  building_wall_left = 9999999.9_wp             !< 
-    REAL(wp) ::  building_wall_south = 9999999.9_wp            !< 
-    REAL(wp) ::  canyon_height = 50.0_wp                       !< 
-    REAL(wp) ::  canyon_width_x = 9999999.9_wp                 !< 
-    REAL(wp) ::  canyon_width_y = 9999999.9_wp                 !< 
-    REAL(wp) ::  canyon_wall_left = 9999999.9_wp               !< 
-    REAL(wp) ::  canyon_wall_south = 9999999.9_wp              !< 
-    REAL(wp) ::  cfl_factor = -1.0_wp                          !< 
-    REAL(wp) ::  cos_alpha_surface                             !< 
-    REAL(wp) ::  coupling_start_time = 0.0_wp                  !< 
-    REAL(wp) ::  disturbance_amplitude = 0.25_wp               !< 
-    REAL(wp) ::  disturbance_energy_limit = 0.01_wp            !< 
-    REAL(wp) ::  disturbance_level_b = -9999999.9_wp           !< 
-    REAL(wp) ::  disturbance_level_t = -9999999.9_wp           !< 
-    REAL(wp) ::  dp_level_b = 0.0_wp                           !< 
-    REAL(wp) ::  dt = -1.0_wp                                  !< 
-    REAL(wp) ::  dt_averaging_input = 0.0_wp                   !< 
-    REAL(wp) ::  dt_averaging_input_pr = 9999999.9_wp          !< 
-    REAL(wp) ::  dt_coupling = 9999999.9_wp                    !< 
-    REAL(wp) ::  dt_data_output = 9999999.9_wp                 !< 
-    REAL(wp) ::  dt_data_output_av = 9999999.9_wp              !< 
-    REAL(wp) ::  dt_disturb = 9999999.9_wp                     !< 
-    REAL(wp) ::  dt_dopr = 9999999.9_wp                        !< 
-    REAL(wp) ::  dt_dopr_listing = 9999999.9_wp                !< 
-    REAL(wp) ::  dt_dopts = 9999999.9_wp                       !< 
-    REAL(wp) ::  dt_dots = 9999999.9_wp                        !< 
-    REAL(wp) ::  dt_do2d_xy = 9999999.9_wp                     !< 
-    REAL(wp) ::  dt_do2d_xz = 9999999.9_wp                     !< 
-    REAL(wp) ::  dt_do2d_yz = 9999999.9_wp                     !< 
-    REAL(wp) ::  dt_do3d = 9999999.9_wp                        !< 
-    REAL(wp) ::  dt_dvrp = 9999999.9_wp                        !< 
-    REAL(wp) ::  dt_max = 20.0_wp                              !< 
-    REAL(wp) ::  dt_restart = 9999999.9_wp                     !< 
-    REAL(wp) ::  dt_run_control = 60.0_wp                      !< 
-    REAL(wp) ::  dt_3d = 1.0_wp                                !< 
-    REAL(wp) ::  dz = -1.0_wp                                  !< 
-    REAL(wp) ::  dz_max = 9999999.9_wp                         !< 
-    REAL(wp) ::  dz_stretch_factor = 1.08_wp                   !< 
-    REAL(wp) ::  dz_stretch_level = 100000.0_wp                !< 
-    REAL(wp) ::  e_init = 0.0_wp                               !< 
-    REAL(wp) ::  e_min = 0.0_wp                                !< 
-    REAL(wp) ::  end_time = 0.0_wp                             !< 
-    REAL(wp) ::  f = 0.0_wp                                    !< 
-    REAL(wp) ::  fs = 0.0_wp                                   !< 
-    REAL(wp) ::  g = 9.81_wp                                   !< 
-    REAL(wp) ::  inflow_damping_height = 9999999.9_wp          !< 
-    REAL(wp) ::  inflow_damping_width = 9999999.9_wp           !< 
-    REAL(wp) ::  kappa = 0.4_wp                                !< 
-    REAL(wp) ::  km_constant = -1.0_wp                         !< 
-    REAL(wp) ::  mask_scale_x = 1.0_wp                         !< 
-    REAL(wp) ::  mask_scale_y = 1.0_wp                         !< 
-    REAL(wp) ::  mask_scale_z = 1.0_wp                         !< 
-    REAL(wp) ::  maximum_cpu_time_allowed = 0.0_wp             !< 
-    REAL(wp) ::  molecular_viscosity = 1.461E-5_wp             !< 
-    REAL(wp) ::  old_dt = 1.0E-10_wp                           !< 
-    REAL(wp) ::  omega = 7.29212E-5_wp                         !< 
-    REAL(wp) ::  omega_sor = 1.8_wp                            !< 
-    REAL(wp) ::  outflow_source_plane = -9999999.9_wp          !< x-position of outflow-source plane (turbulent outflow method)
-    REAL(wp) ::  particle_maximum_age = 9999999.9_wp           !< 
-    REAL(wp) ::  phi = 55.0_wp                                 !< 
-    REAL(wp) ::  prandtl_number = 1.0_wp                       !< 
-    REAL(wp) ::  precipitation_amount_interval = 9999999.9_wp  !< 
-    REAL(wp) ::  prho_reference                                !< 
-    REAL(wp) ::  pt_damping_factor = 0.0_wp                    !< 
-    REAL(wp) ::  pt_damping_width = 0.0_wp                     !< 
-    REAL(wp) ::  pt_reference = 9999999.9_wp                   !< 
-    REAL(wp) ::  pt_slope_offset = 0.0_wp                      !< 
-    REAL(wp) ::  pt_surface = 300.0_wp                         !< 
-    REAL(wp) ::  pt_surface_initial_change = 0.0_wp            !< 
-    REAL(wp) ::  q_surface = 0.0_wp                            !< 
-    REAL(wp) ::  q_surface_initial_change = 0.0_wp             !< 
-    REAL(wp) ::  rayleigh_damping_factor = -1.0_wp             !< 
-    REAL(wp) ::  rayleigh_damping_height = -1.0_wp             !< 
-    REAL(wp) ::  recycling_width = 9999999.9_wp                !< 
-    REAL(wp) ::  residual_limit = 1.0E-4_wp                    !< 
-    REAL(wp) ::  restart_time = 9999999.9_wp                   !< 
-    REAL(wp) ::  rho_reference                                 !< 
-    REAL(wp) ::  rho_surface                                   !< 
-    REAL(wp) ::  roughness_length = 0.1_wp                     !< 
-    REAL(wp) ::  sa_surface = 35.0_wp                          !< 
-    REAL(wp) ::  simulated_time = 0.0_wp                       !< 
-    REAL(wp) ::  simulated_time_at_begin                       !< 
-    REAL(wp) ::  sin_alpha_surface                             !< 
-    REAL(wp) ::  skip_time_data_output = 0.0_wp                !< 
-    REAL(wp) ::  skip_time_data_output_av = 9999999.9_wp       !< 
-    REAL(wp) ::  skip_time_dopr = 9999999.9_wp                 !< 
-    REAL(wp) ::  skip_time_do2d_xy = 9999999.9_wp              !< 
-    REAL(wp) ::  skip_time_do2d_xz = 9999999.9_wp              !< 
-    REAL(wp) ::  skip_time_do2d_yz = 9999999.9_wp              !< 
-    REAL(wp) ::  skip_time_do3d = 9999999.9_wp                 !< 
-    REAL(wp) ::  surface_heatflux = 9999999.9_wp               !< 
-    REAL(wp) ::  surface_pressure = 1013.25_wp                 !< 
-    REAL(wp) ::  surface_scalarflux = 9999999.9_wp             !< 
-    REAL(wp) ::  surface_waterflux = 9999999.9_wp              !< 
-    REAL(wp) ::  s_surface = 0.0_wp                            !< 
-    REAL(wp) ::  s_surface_initial_change = 0.0_wp             !< 
-    REAL(wp) ::  termination_time_needed = -1.0_wp             !< 
-    REAL(wp) ::  time_coupling = 0.0_wp                        !< 
-    REAL(wp) ::  time_disturb = 0.0_wp                         !< 
-    REAL(wp) ::  time_dopr = 0.0_wp                            !< 
-    REAL(wp) ::  time_dopr_av = 0.0_wp                         !< 
-    REAL(wp) ::  time_dopr_listing = 0.0_wp                    !< 
-    REAL(wp) ::  time_dopts = 0.0_wp                           !< 
-    REAL(wp) ::  time_dosp = 0.0_wp                            !< 
-    REAL(wp) ::  time_dosp_av = 0.0_wp                         !< 
-    REAL(wp) ::  time_dots = 0.0_wp                            !< 
-    REAL(wp) ::  time_do2d_xy = 0.0_wp                         !< 
-    REAL(wp) ::  time_do2d_xz = 0.0_wp                         !< 
-    REAL(wp) ::  time_do2d_yz = 0.0_wp                         !< 
-    REAL(wp) ::  time_do3d = 0.0_wp                            !< 
-    REAL(wp) ::  time_do_av = 0.0_wp                           !< 
-    REAL(wp) ::  time_do_sla = 0.0_wp                          !< 
-    REAL(wp) ::  time_dvrp = 0.0_wp                            !< 
-    REAL(wp) ::  time_restart = 9999999.9_wp                   !< 
-    REAL(wp) ::  time_run_control = 0.0_wp                     !< 
-    REAL(wp) ::  time_since_reference_point                    !< 
-    REAL(wp) ::  top_heatflux = 9999999.9_wp                   !< 
-    REAL(wp) ::  top_momentumflux_u = 9999999.9_wp             !< 
-    REAL(wp) ::  top_momentumflux_v = 9999999.9_wp             !< 
-    REAL(wp) ::  top_salinityflux = 9999999.9_wp               !< 
-    REAL(wp) ::  top_scalarflux = 9999999.9_wp                 !< 
-    REAL(wp) ::  tunnel_height = 9999999.9_wp                  !< height of tunnel outer wall
-    REAL(wp) ::  tunnel_length = 9999999.9_wp                  !< tunnel length
-    REAL(wp) ::  tunnel_width_x = 9999999.9_wp                 !< tunnel width in x, with respect to outer wall
-    REAL(wp) ::  tunnel_width_y = 9999999.9_wp                 !< tunnel width in y, with respect to outer wall
-    REAL(wp) ::  tunnel_wall_depth = 9999999.9_wp              !< tunnel wall depth
-    REAL(wp) ::  ug_surface = 0.0_wp                           !< 
-    REAL(wp) ::  u_bulk = 0.0_wp                               !< 
-    REAL(wp) ::  u_gtrans = 0.0_wp                             !< 
-    REAL(wp) ::  vg_surface = 0.0_wp                           !< 
-    REAL(wp) ::  vpt_reference = 9999999.9_wp                  !< 
-    REAL(wp) ::  v_bulk = 0.0_wp                               !< 
-    REAL(wp) ::  v_gtrans = 0.0_wp                             !< 
-    REAL(wp) ::  wall_adjustment_factor = 1.8_wp               !< 
-    REAL(wp) ::  zeta_max = 20.0_wp                            !< Maximum value of zeta = z/L
-    REAL(wp) ::  zeta_min = -20.0_wp                           !< Minimum value of zeta = z/L
-    REAL(wp) ::  z_max_do2d = -1.0_wp                          !< 
-    REAL(wp) ::  z0h_factor = 1.0_wp                           !< 
-
-    REAL(wp) ::  do2d_xy_last_time(0:1) = -1.0_wp                  !< 
-    REAL(wp) ::  do2d_xz_last_time(0:1) = -1.0_wp                  !< 
-    REAL(wp) ::  do2d_yz_last_time(0:1) = -1.0_wp                  !< 
-    REAL(wp) ::  dpdxy(1:2) = 0.0_wp                               !< 
-    REAL(wp) ::  dt_domask(max_masks) = 9999999.9_wp               !< 
-    REAL(wp) ::  mask_scale(3)                                     !< 
-    REAL(wp) ::  pt_vertical_gradient(10) = 0.0_wp                 !< 
-    REAL(wp) ::  pt_vertical_gradient_level(10) = -1.0_wp          !< 
-    REAL(wp) ::  q_vertical_gradient(10) = 0.0_wp                  !< 
-    REAL(wp) ::  q_vertical_gradient_level(10) = -1.0_wp           !< 
-    REAL(wp) ::  s_vertical_gradient(10) = 0.0_wp                  !< 
-    REAL(wp) ::  s_vertical_gradient_level(10) = -1.0_wp           !< 
-    REAL(wp) ::  sa_vertical_gradient(10) = 0.0_wp                 !< 
-    REAL(wp) ::  sa_vertical_gradient_level(10) = -1.0_wp          !< 
-    REAL(wp) ::  skip_time_domask(max_masks) = 9999999.9_wp        !< 
-    REAL(wp) ::  threshold(20) = 0.0_wp                            !< 
-    REAL(wp) ::  time_domask(max_masks) = 0.0_wp                   !< 
-    REAL(wp) ::  tsc(10) = (/ 1.0_wp, 1.0_wp, 0.0_wp, 0.0_wp, &    !< 
+    LOGICAL ::  terminate_run = .FALSE.                      !< terminate run (cpu-time limit, restarts)?
+    LOGICAL ::  transpose_compute_overlap = .FALSE.          !< namelist parameter
+    LOGICAL ::  turbulent_inflow = .FALSE.                   !< namelist parameter
+    LOGICAL ::  turbulent_outflow = .FALSE.                  !< namelist parameter
+    LOGICAL ::  urban_surface = .FALSE.                      !< use urban surface model?
+    LOGICAL ::  use_cmax = .TRUE.                            !< namelist parameter
+    LOGICAL ::  use_initial_profile_as_reference = .FALSE.   !< use of initial profiles as reference state?
+    LOGICAL ::  use_prescribed_profile_data = .FALSE.        !< use of prescribed wind profiles?
+                                                             !< (namelist parameters u_profile, v_profile)
+    LOGICAL ::  use_single_reference_value = .FALSE.         !< use of single value as reference state?
+    LOGICAL ::  use_subsidence_tendencies = .FALSE.          !< namelist parameter
+    LOGICAL ::  use_surface_fluxes = .FALSE.                 !< namelist parameter
+    LOGICAL ::  use_top_fluxes = .FALSE.                     !< namelist parameter
+    LOGICAL ::  use_ug_for_galilei_tr = .TRUE.               !< namelist parameter
+    LOGICAL ::  use_upstream_for_tke = .FALSE.               !< namelist parameter
+    LOGICAL ::  virtual_flight = .FALSE.                     !< use virtual flight model?
+    LOGICAL ::  wall_adjustment = .TRUE.                     !< namelist parameter
+    LOGICAL ::  ws_scheme_sca = .FALSE.                      !< use Wicker-Skamarock scheme (scalar advection)?
+    LOGICAL ::  ws_scheme_mom = .FALSE.                      !< use Wicker-Skamarock scheme (momentum advection)?
+    LOGICAL ::  data_output_xy(0:1) = .FALSE.                !< output of xy cross-section data?
+    LOGICAL ::  data_output_xz(0:1) = .FALSE.                !< output of xz cross-section data?
+    LOGICAL ::  data_output_yz(0:1) = .FALSE.                !< output of yz cross-section data?
+
+    REAL(wp) ::  advected_distance_x = 0.0_wp                  !< advected distance of model domain along x 
+                                                               !< (galilei transformation) 
+    REAL(wp) ::  advected_distance_y = 0.0_wp                  !< advected distance of model domain along y 
+                                                               !< (galilei transformation)
+    REAL(wp) ::  alpha_surface = 0.0_wp                        !< namelist parameter
+    REAL(wp) ::  atmos_ocean_sign = 1.0_wp                     !< vertical-grid conversion factor 
+                                                               !< (=1.0 in atmosphere, =-1.0 in ocean)
+    REAL(wp) ::  averaging_interval = 0.0_wp                   !< namelist parameter
+    REAL(wp) ::  averaging_interval_pr = 9999999.9_wp          !< namelist parameter
+    REAL(wp) ::  bc_pt_t_val                                   !< vertical gradient of pt near domain top
+    REAL(wp) ::  bc_q_t_val                                    !< vertical gradient of humidity near domain top
+    REAL(wp) ::  bc_s_t_val                                    !< vertical gradient of passive scalar near domain top
+    REAL(wp) ::  bottom_salinityflux = 0.0_wp                  !< namelist parameter
+    REAL(wp) ::  building_height = 50.0_wp                     !< namelist parameter
+    REAL(wp) ::  building_length_x = 50.0_wp                   !< namelist parameter
+    REAL(wp) ::  building_length_y = 50.0_wp                   !< namelist parameter
+    REAL(wp) ::  building_wall_left = 9999999.9_wp             !< namelist parameter
+    REAL(wp) ::  building_wall_south = 9999999.9_wp            !< namelist parameter
+    REAL(wp) ::  canyon_height = 50.0_wp                       !< namelist parameter
+    REAL(wp) ::  canyon_width_x = 9999999.9_wp                 !< namelist parameter
+    REAL(wp) ::  canyon_width_y = 9999999.9_wp                 !< namelist parameter
+    REAL(wp) ::  canyon_wall_left = 9999999.9_wp               !< namelist parameter
+    REAL(wp) ::  canyon_wall_south = 9999999.9_wp              !< namelist parameter
+    REAL(wp) ::  cfl_factor = -1.0_wp                          !< namelist parameter
+    REAL(wp) ::  cos_alpha_surface                             !< cosine of alpha_surface
+    REAL(wp) ::  coupling_start_time = 0.0_wp                  !< namelist parameter
+    REAL(wp) ::  disturbance_amplitude = 0.25_wp               !< namelist parameter
+    REAL(wp) ::  disturbance_energy_limit = 0.01_wp            !< namelist parameter
+    REAL(wp) ::  disturbance_level_b = -9999999.9_wp           !< namelist parameter
+    REAL(wp) ::  disturbance_level_t = -9999999.9_wp           !< namelist parameter
+    REAL(wp) ::  dp_level_b = 0.0_wp                           !< namelist parameter
+    REAL(wp) ::  dt = -1.0_wp                                  !< namelist parameter
+    REAL(wp) ::  dt_averaging_input = 0.0_wp                   !< namelist parameter
+    REAL(wp) ::  dt_averaging_input_pr = 9999999.9_wp          !< namelist parameter
+    REAL(wp) ::  dt_coupling = 9999999.9_wp                    !< namelist parameter
+    REAL(wp) ::  dt_data_output = 9999999.9_wp                 !< namelist parameter
+    REAL(wp) ::  dt_data_output_av = 9999999.9_wp              !< namelist parameter
+    REAL(wp) ::  dt_disturb = 9999999.9_wp                     !< namelist parameter
+    REAL(wp) ::  dt_dopr = 9999999.9_wp                        !< namelist parameter
+    REAL(wp) ::  dt_dopr_listing = 9999999.9_wp                !< namelist parameter
+    REAL(wp) ::  dt_dopts = 9999999.9_wp                       !< namelist parameter
+    REAL(wp) ::  dt_dots = 9999999.9_wp                        !< namelist parameter
+    REAL(wp) ::  dt_do2d_xy = 9999999.9_wp                     !< namelist parameter
+    REAL(wp) ::  dt_do2d_xz = 9999999.9_wp                     !< namelist parameter
+    REAL(wp) ::  dt_do2d_yz = 9999999.9_wp                     !< namelist parameter
+    REAL(wp) ::  dt_do3d = 9999999.9_wp                        !< namelist parameter
+    REAL(wp) ::  dt_dvrp = 9999999.9_wp                        !< namelist parameter
+    REAL(wp) ::  dt_max = 20.0_wp                              !< namelist parameter
+    REAL(wp) ::  dt_restart = 9999999.9_wp                     !< namelist parameter
+    REAL(wp) ::  dt_run_control = 60.0_wp                      !< namelist parameter
+    REAL(wp) ::  dt_3d = 1.0_wp                                !< time step
+    REAL(wp) ::  dz = -1.0_wp                                  !< namelist parameter
+    REAL(wp) ::  dz_max = 9999999.9_wp                         !< namelist parameter
+    REAL(wp) ::  dz_stretch_factor = 1.08_wp                   !< namelist parameter
+    REAL(wp) ::  dz_stretch_level = 100000.0_wp                !< namelist parameter
+    REAL(wp) ::  e_init = 0.0_wp                               !< namelist parameter
+    REAL(wp) ::  e_min = 0.0_wp                                !< namelist parameter
+    REAL(wp) ::  end_time = 0.0_wp                             !< namelist parameter
+    REAL(wp) ::  f = 0.0_wp                                    !< Coriolis parameter
+    REAL(wp) ::  fs = 0.0_wp                                   !< Coriolis parameter
+    REAL(wp) ::  g = 9.81_wp                                   !< gravitational acceleration
+    REAL(wp) ::  inflow_damping_height = 9999999.9_wp          !< namelist parameter
+    REAL(wp) ::  inflow_damping_width = 9999999.9_wp           !< namelist parameter
+    REAL(wp) ::  kappa = 0.4_wp                                !< von Karman constant
+    REAL(wp) ::  km_constant = -1.0_wp                         !< namelist parameter
+    REAL(wp) ::  mask_scale_x = 1.0_wp                         !< namelist parameter
+    REAL(wp) ::  mask_scale_y = 1.0_wp                         !< namelist parameter
+    REAL(wp) ::  mask_scale_z = 1.0_wp                         !< namelist parameter
+    REAL(wp) ::  maximum_cpu_time_allowed = 0.0_wp             !< given wall time for run
+    REAL(wp) ::  molecular_viscosity = 1.461E-5_wp             !< molecular viscosity (used in lsm and lpm)
+    REAL(wp) ::  old_dt = 1.0E-10_wp                           !< length of previous timestep
+    REAL(wp) ::  omega = 7.29212E-5_wp                         !< namelist parameter
+    REAL(wp) ::  omega_sor = 1.8_wp                            !< namelist parameter
+    REAL(wp) ::  outflow_source_plane = -9999999.9_wp          !< namelist parameter
+    REAL(wp) ::  particle_maximum_age = 9999999.9_wp           !< namelist parameter
+    REAL(wp) ::  phi = 55.0_wp                                 !< namelist parameter
+    REAL(wp) ::  prandtl_number = 1.0_wp                       !< namelist parameter
+    REAL(wp) ::  precipitation_amount_interval = 9999999.9_wp  !< namelist parameter
+    REAL(wp) ::  prho_reference                                !< reference state of potential density
+    REAL(wp) ::  pt_damping_factor = 0.0_wp                    !< namelist parameter
+    REAL(wp) ::  pt_damping_width = 0.0_wp                     !< namelist parameter
+    REAL(wp) ::  pt_reference = 9999999.9_wp                   !< namelist parameter
+    REAL(wp) ::  pt_slope_offset = 0.0_wp                      !< temperature difference between left and right 
+                                                               !< boundary of total domain
+    REAL(wp) ::  pt_surface = 300.0_wp                         !< namelist parameter
+    REAL(wp) ::  pt_surface_initial_change = 0.0_wp            !< namelist parameter
+    REAL(wp) ::  q_surface = 0.0_wp                            !< namelist parameter
+    REAL(wp) ::  q_surface_initial_change = 0.0_wp             !< namelist parameter
+    REAL(wp) ::  rayleigh_damping_factor = -1.0_wp             !< namelist parameter
+    REAL(wp) ::  rayleigh_damping_height = -1.0_wp             !< namelist parameter
+    REAL(wp) ::  recycling_width = 9999999.9_wp                !< namelist parameter
+    REAL(wp) ::  residual_limit = 1.0E-4_wp                    !< namelist parameter
+    REAL(wp) ::  restart_time = 9999999.9_wp                   !< namelist parameter
+    REAL(wp) ::  rho_reference                                 !< reference state of density
+    REAL(wp) ::  rho_surface                                   !< surface value of density
+    REAL(wp) ::  roughness_length = 0.1_wp                     !< namelist parameter
+    REAL(wp) ::  sa_surface = 35.0_wp                          !< namelist parameter
+    REAL(wp) ::  simulated_time = 0.0_wp                       !< elapsed simulated time
+    REAL(wp) ::  simulated_time_at_begin                       !< elapsed simulated time of previous run (job chain)
+    REAL(wp) ::  sin_alpha_surface                             !< sine of alpha_surface (sloped surface)
+    REAL(wp) ::  skip_time_data_output = 0.0_wp                !< namelist parameter
+    REAL(wp) ::  skip_time_data_output_av = 9999999.9_wp       !< namelist parameter
+    REAL(wp) ::  skip_time_dopr = 9999999.9_wp                 !< namelist parameter
+    REAL(wp) ::  skip_time_do2d_xy = 9999999.9_wp              !< namelist parameter
+    REAL(wp) ::  skip_time_do2d_xz = 9999999.9_wp              !< namelist parameter
+    REAL(wp) ::  skip_time_do2d_yz = 9999999.9_wp              !< namelist parameter
+    REAL(wp) ::  skip_time_do3d = 9999999.9_wp                 !< namelist parameter
+    REAL(wp) ::  surface_heatflux = 9999999.9_wp               !< namelist parameter
+    REAL(wp) ::  surface_pressure = 1013.25_wp                 !< namelist parameter
+    REAL(wp) ::  surface_scalarflux = 9999999.9_wp             !< namelist parameter
+    REAL(wp) ::  surface_waterflux = 9999999.9_wp              !< namelist parameter
+    REAL(wp) ::  s_surface = 0.0_wp                            !< namelist parameter
+    REAL(wp) ::  s_surface_initial_change = 0.0_wp             !< namelist parameter
+    REAL(wp) ::  termination_time_needed = -1.0_wp             !< namelist parameter
+    REAL(wp) ::  time_coupling = 0.0_wp                        !< time since last coupling (surface_coupler)
+    REAL(wp) ::  time_disturb = 0.0_wp                         !< time since last flow disturbance
+    REAL(wp) ::  time_dopr = 0.0_wp                            !< time since last profile output
+    REAL(wp) ::  time_dopr_av = 0.0_wp                         !< time since last averaged profile output
+    REAL(wp) ::  time_dopr_listing = 0.0_wp                    !< time since last profile output (ASCII) on file
+    REAL(wp) ::  time_dopts = 0.0_wp                           !< time since last particle timeseries output
+    REAL(wp) ::  time_dosp = 0.0_wp                            !< time since last spectra output
+    REAL(wp) ::  time_dosp_av = 0.0_wp                         !< time since last averaged spectra output
+    REAL(wp) ::  time_dots = 0.0_wp                            !< time since last timeseries output
+    REAL(wp) ::  time_do2d_xy = 0.0_wp                         !< time since last xy cross-section output
+    REAL(wp) ::  time_do2d_xz = 0.0_wp                         !< time since last xz cross-section output
+    REAL(wp) ::  time_do2d_yz = 0.0_wp                         !< time since last yz cross-section output
+    REAL(wp) ::  time_do3d = 0.0_wp                            !< time since last 3d output
+    REAL(wp) ::  time_do_av = 0.0_wp                           !< time since last averaged-data output
+    REAL(wp) ::  time_do_sla = 0.0_wp                          !< time since last 
+    REAL(wp) ::  time_dvrp = 0.0_wp                            !< time since last dvrp output
+    REAL(wp) ::  time_restart = 9999999.9_wp                   !< time at which run shall be terminated and restarted
+    REAL(wp) ::  time_run_control = 0.0_wp                     !< time since last RUN_CONTROL output
+    REAL(wp) ::  time_since_reference_point                    !< Siggi
+    REAL(wp) ::  top_heatflux = 9999999.9_wp                   !< namelist parameter
+    REAL(wp) ::  top_momentumflux_u = 9999999.9_wp             !< namelist parameter
+    REAL(wp) ::  top_momentumflux_v = 9999999.9_wp             !< namelist parameter
+    REAL(wp) ::  top_salinityflux = 9999999.9_wp               !< namelist parameter
+    REAL(wp) ::  top_scalarflux = 9999999.9_wp                 !< namelist parameter
+    REAL(wp) ::  tunnel_height = 9999999.9_wp                  !< namelist parameter
+    REAL(wp) ::  tunnel_length = 9999999.9_wp                  !< namelist parameter
+    REAL(wp) ::  tunnel_width_x = 9999999.9_wp                 !< namelist parameter
+    REAL(wp) ::  tunnel_width_y = 9999999.9_wp                 !< namelist parameter
+    REAL(wp) ::  tunnel_wall_depth = 9999999.9_wp              !< namelist parameter
+    REAL(wp) ::  ug_surface = 0.0_wp                           !< namelist parameter 
+    REAL(wp) ::  u_bulk = 0.0_wp                               !< namelist parameter 
+    REAL(wp) ::  u_gtrans = 0.0_wp                             !< transformed wind component (galilei transformation)
+    REAL(wp) ::  vg_surface = 0.0_wp                           !< namelist parameter
+    REAL(wp) ::  vpt_reference = 9999999.9_wp                  !< reference state of virtual potential temperature
+    REAL(wp) ::  v_bulk = 0.0_wp                               !< namelist parameter
+    REAL(wp) ::  v_gtrans = 0.0_wp                             !< transformed wind component (galilei transformation)
+    REAL(wp) ::  wall_adjustment_factor = 1.8_wp               !< adjustment factor for mixing length l
+    REAL(wp) ::  zeta_max = 20.0_wp                            !< namelist parameter
+    REAL(wp) ::  zeta_min = -20.0_wp                           !< namelist parameter
+    REAL(wp) ::  z_max_do2d = -1.0_wp                          !< namelist parameter
+    REAL(wp) ::  z0h_factor = 1.0_wp                           !< namelist parameter
+
+    REAL(wp) ::  do2d_xy_last_time(0:1) = -1.0_wp                  !< time of previous xy output
+    REAL(wp) ::  do2d_xz_last_time(0:1) = -1.0_wp                  !< time of previous xz output
+    REAL(wp) ::  do2d_yz_last_time(0:1) = -1.0_wp                  !< time of previous yz output
+    REAL(wp) ::  dpdxy(1:2) = 0.0_wp                               !< namelist parameter
+    REAL(wp) ::  dt_domask(max_masks) = 9999999.9_wp               !< namelist parameter
+    REAL(wp) ::  mask_scale(3)                                     !< collective array for mask_scale_x/y/z
+    REAL(wp) ::  pt_vertical_gradient(10) = 0.0_wp                 !< namelist parameter
+    REAL(wp) ::  pt_vertical_gradient_level(10) = -1.0_wp          !< namelist parameter
+    REAL(wp) ::  q_vertical_gradient(10) = 0.0_wp                  !< namelist parameter
+    REAL(wp) ::  q_vertical_gradient_level(10) = -1.0_wp           !< namelist parameter
+    REAL(wp) ::  s_vertical_gradient(10) = 0.0_wp                  !< namelist parameter
+    REAL(wp) ::  s_vertical_gradient_level(10) = -1.0_wp           !< namelist parameter
+    REAL(wp) ::  sa_vertical_gradient(10) = 0.0_wp                 !< namelist parameter
+    REAL(wp) ::  sa_vertical_gradient_level(10) = -1.0_wp          !< namelist parameter
+    REAL(wp) ::  skip_time_domask(max_masks) = 9999999.9_wp        !< namelist parameter
+    REAL(wp) ::  threshold(20) = 0.0_wp                            !< namelist parameter
+    REAL(wp) ::  time_domask(max_masks) = 0.0_wp                   !< namelist parameter
+    REAL(wp) ::  tsc(10) = (/ 1.0_wp, 1.0_wp, 0.0_wp, 0.0_wp, &    !< array used for controlling time-integration at different substeps
                  0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp /)
-    REAL(wp) ::  u_profile(100) = 9999999.9_wp                     !< 
-    REAL(wp) ::  uv_heights(100) = 9999999.9_wp                    !< 
-    REAL(wp) ::  v_profile(100) = 9999999.9_wp                     !< 
-    REAL(wp) ::  ug_vertical_gradient(10) = 0.0_wp                 !< 
-    REAL(wp) ::  ug_vertical_gradient_level(10) = -9999999.9_wp    !< 
-    REAL(wp) ::  vg_vertical_gradient(10) = 0.0_wp                 !< 
-    REAL(wp) ::  vg_vertical_gradient_level(10) = -9999999.9_wp    !< 
-    REAL(wp) ::  volume_flow(1:3) = 0.0_wp                         !< 
-    REAL(wp) ::  volume_flow_area(1:3) = 0.0_wp                    !< 
-    REAL(wp) ::  volume_flow_initial(1:3) = 0.0_wp                 !< 
-    REAL(wp) ::  wall_heatflux(0:5) = 0.0_wp                       !< 
-    REAL(wp) ::  wall_humidityflux(0:5) = 0.0_wp                   !< 
-    REAL(wp) ::  wall_salinityflux(0:5) = 0.0_wp                   !< 
-    REAL(wp) ::  wall_scalarflux(0:5) = 0.0_wp                     !< 
-    REAL(wp) ::  subs_vertical_gradient(10) = 0.0_wp               !< 
-    REAL(wp) ::  subs_vertical_gradient_level(10) = -9999999.9_wp  !< 
-
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  dp_smooth_factor  !< 
-
-    REAL(wp), DIMENSION(max_masks,mask_xyz_dimension) ::  mask_x = -1.0_wp  !< 
-    REAL(wp), DIMENSION(max_masks,mask_xyz_dimension) ::  mask_y = -1.0_wp  !< 
-    REAL(wp), DIMENSION(max_masks,mask_xyz_dimension) ::  mask_z = -1.0_wp  !<
+    REAL(wp) ::  u_profile(100) = 9999999.9_wp                     !< namelist parameter
+    REAL(wp) ::  uv_heights(100) = 9999999.9_wp                    !< namelist parameter
+    REAL(wp) ::  v_profile(100) = 9999999.9_wp                     !< namelist parameter
+    REAL(wp) ::  ug_vertical_gradient(10) = 0.0_wp                 !< namelist parameter
+    REAL(wp) ::  ug_vertical_gradient_level(10) = -9999999.9_wp    !< namelist parameter
+    REAL(wp) ::  vg_vertical_gradient(10) = 0.0_wp                 !< namelist parameter
+    REAL(wp) ::  vg_vertical_gradient_level(10) = -9999999.9_wp    !< namelist parameter
+    REAL(wp) ::  volume_flow(1:3) = 0.0_wp                         !< Siggi
+    REAL(wp) ::  volume_flow_area(1:3) = 0.0_wp                    !< Siggi
+    REAL(wp) ::  volume_flow_initial(1:3) = 0.0_wp                 !< Siggi
+    REAL(wp) ::  wall_heatflux(0:5) = 0.0_wp                       !< namelist parameter
+    REAL(wp) ::  wall_humidityflux(0:5) = 0.0_wp                   !< namelist parameter
+    REAL(wp) ::  wall_salinityflux(0:5) = 0.0_wp                   !< namelist parameter
+    REAL(wp) ::  wall_scalarflux(0:5) = 0.0_wp                     !< namelist parameter 
+    REAL(wp) ::  subs_vertical_gradient(10) = 0.0_wp               !< namelist parameter 
+    REAL(wp) ::  subs_vertical_gradient_level(10) = -9999999.9_wp  !< namelist parameter
+
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  dp_smooth_factor  !< smoothing factor for external pressure gradient forcing
+
+    REAL(wp), DIMENSION(max_masks,mask_xyz_dimension) ::  mask_x = -1.0_wp  !< namelist parameter
+    REAL(wp), DIMENSION(max_masks,mask_xyz_dimension) ::  mask_y = -1.0_wp  !< namelist parameter
+    REAL(wp), DIMENSION(max_masks,mask_xyz_dimension) ::  mask_z = -1.0_wp  !< namelist parameter
     
-    REAL(wp), DIMENSION(max_masks,3) ::  mask_x_loop = -1.0_wp  !< 
-    REAL(wp), DIMENSION(max_masks,3) ::  mask_y_loop = -1.0_wp  !< 
-    REAL(wp), DIMENSION(max_masks,3) ::  mask_z_loop = -1.0_wp  !< 
+    REAL(wp), DIMENSION(max_masks,3) ::  mask_x_loop = -1.0_wp  !< namelist parameter
+    REAL(wp), DIMENSION(max_masks,3) ::  mask_y_loop = -1.0_wp  !< namelist parameter
+    REAL(wp), DIMENSION(max_masks,3) ::  mask_z_loop = -1.0_wp  !< namelist parameter
     
 !
 !--    internal mask arrays ("mask,dimension,selection")
-       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  mask       !< 
-       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  mask_loop  !< 
+       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  mask       !< collective array for mask_x/y/z
+       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  mask_loop  !< collective array for mask_x/y/z_loop
 
     SAVE
